<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" style="width: 800px">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="100px"
    >
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="学员姓名" prop="userName">
            <el-input v-model="formData.userName" placeholder="请输入学员姓名" />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="学员性别">
            <el-radio-group v-model="formData.sex">
              <el-radio :value="1"> 男 </el-radio>
              <el-radio :value="2"> 女 </el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="手机号码" prop="phone">
            <el-input v-model="formData.phone" maxlength="11" placeholder="请输入手机号码" />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="身份证号" prop="idcard">
            <el-input v-model="formData.idcard" maxlength="18" placeholder="请输入身份证号" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="20">
        <el-col :span="12">
          <el-form-item label="考试类型" prop="carTypeId">
            <el-select
              v-model="formData.carTypeIds"
              placeholder="选择考试类型"
              clearable
              filterable
              multiple
              collapse-tags
            >
              <el-option
                v-for="item in cartypeOptions"
                :key="item.carTypeId"
                :label="item.carName"
                :value="item.carTypeId"
              />
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script name="DialogCustomer" setup>

import * as CustomerApi from '@/api/Customer/customer.js'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({})
const formRules = ref({
  userName: [{ required: true, message: '学员姓名不能为空', trigger: 'blur' }],
  idcard: [
    {
      required: true,
      message: '请输入身份证号',
      trigger: 'blur'
    }
  ],
  phone: [{ required: true, message: '手机号不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
const cartypeOptions = ref([])

const deptList = ref([])

/** 打开弹窗 */
const open = async (type, info) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (info?.userId) {
    formData.value = { ...info }
  }
  getOptions()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

function getOptions() {
  CustomerApi.getCustomerExamCarType().then((data) => {
    cartypeOptions.value = data
  })
}

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    if (formType.value === 'create') {
      await CustomerApi.createCustomer(data)
      message.success(t('common.createSuccess'))
    } else {
      await CustomerApi.updateCustomer(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    userName: '',
    phone: '',
    idcard: '',
    id: undefined,
    sex: 1,
    carTypeIds: [1011]
  }
  formRef.value?.resetFields()
}
</script>
